/**
 * Module dependencies.
 */

var express = require('express'),
    routes = require('./routes'),
    http = require('http'),
    https = require('https'),
    fs = require('fs');

var app = express();

app.configure(function () {
    app.set('port', process.env.PORT || 3000);
    app.use(express.favicon());
    app.use(express.logger('dev'));
    app.use(express.bodyParser());
    app.use(express.methodOverride());
    app.use(app.router);
    app.use(express.static(__dirname + '/public'));
    app.use(express.cookieParser({secret:"js ninja"}));
});

app.configure('development', function () {
    app.use(express.errorHandler());
});

app.use(function (req, res, next) {
    var schema = req.headers["x-forwarded-proto"];

    // --- Do nothing if schema is already https
    if (schema === "https")
        return next();

    // --- Redirect to https
    res.redirect("https://" + req.headers.host + req.url);
});

// 404 Page
app.use(function (req, res, next) {
    res.sendfile('views/404.html');
});

app.get('/', routes.index);

var options = {
    key:fs.readFileSync('snynckey.pem'),
    cert:fs.readFileSync('snynccert.pem')
};

https.createServer(options, app).listen(app.get('port'), function () {
    console.log("Express server listening on port " + app.get('port'));
});